<?php
/***************************************************************************\
 *  Exemple basique de panel minimal pour inviter une personne a disposer  *
 *  d'un site spip mutualisé.                                              *
 *                                                                         *
 *    Voir : http://www.spip-contrib.net/La-mutualisation-facile           *
 *           http://www.spip-contrib.net/Hebergement-mutualise-spip        *
 *                                                                         *
 * Nécessite les paquets pear suivants :                                   *
 *                                                                         *
 *   - HTML_QuickForm, HTML_QuickForm_Renderer_Tableless                   *
 *   - Net_SMTP, Mail, Net_Ping                                            *
 *                                                                         *
 *  Philippe Drouot - Distribue sous licence GNU/GPL.                      *
 *                                                                         *
 *                                                                         *
\***************************************************************************/

// Authentification avec librairie Pear Auth
require_once 'Auth.php';
require_once 'etc/config.inc.php';
require_once 'include/login.inc.php';
$moderateur = new Auth("DB", $auth_params, "loginFunction");
$moderateur->start();

if (!$moderateur->getAuth()) exit;

//$uid=$moderateur->getAuthData('uid');


// Inclusion librairies PEAR
require_once 'HTML/QuickForm.php';
require_once 'HTML/QuickForm/Renderer/Tableless.php';
require_once 'Mail.php';
	
// Inclusion entete de la page HTML
include 'include/header.inc.php';

// Juste pour afficher le nom du moderateur et permettre de se deconnecter
echo '<div style="margin:10px 10px 10px 0;text-align:right">';
echo 'Vous êtes : '.$moderateur->getAuthData('prenom').' '.$moderateur->getAuthData('nom').'<br />';
echo '<a href="logout.php">Me déconnecter</a>';
echo '</div>';

// Inclusion fct utilitaires : regles quickform de verif + generation code aleatoire
include 'include/utils.inc.php';

// INSTANCIATION DU FORMULAIRE HTML_QUICKFORM (SANS TABLEAUX HTML !)
$form = new HTML_QuickForm("panel","post","","","",TRUE);
$renderer =& new HTML_QuickForm_Renderer_Tableless();
$form->applyFilter('__ALL__','trim');
$form->setRequiredNote('<span style="font-size:80%; color:#ff0000;">*</span><span style="font-size:80%;"> indique un champ requis</span>');
$form->setJsWarnings('Erreur de saisie ','Veuillez corriger');

$form->addElement('header', 'header', 'Inviter quelqu\'un');

// ELEMENTS DU FORMULAIRE LIE AU PROPRIETAIRE DE L'ESPACE : prenom, nom, email
$form->addElement('text','firstname','Prénom :', '', 'server');
$form->addRule('firstname', 'Vous devez saisir un prénom', 'required', '', 'server');
$form->addElement('text','lastname','Nom :');
$form->addRule('lastname', 'Vous devez saisir un nom', 'required', '', 'server');
$form->addElement('text','mail','E-mail :');
$form->addRule('mail', 'Vous devez saisir une adresse électronique', 'required', '', 'server');
$form->addRule('mail', 'Vous devez saisir une adresse email valide ', 'email', '', 'server');
	
// ELEMENTS DU FORMULAIRE LIE A L'ESPACE WEB : url et mot de passe
$form->addElement('text','url','URL (sans www) : http://');
$form->addRule('url', 'Vous devez choisir une URL !', 'required', '', 'server');
$form->addRule('url', "L'URL doit être syntaxiquement correcte (chiffres, lettres minuscules, symboles - et .)", 'regex', '/^[a-z0-9](([a-z0-9]-{0,1})+.)+[a-z]{2,4}$/');		
$form->registerRule('available','function','isSpipUrlAvailable');
$form->addRule('url',"Désolé, cette URL est déjà prise !",'available');
// A decommenter pour une verification IP (on accepte que les domaines avec parametrage DNS deja Ok !
//$form->registerRule('ping','function','pingVerification'); 
//$form->addRule('url',"L'URL doit pointer au préalable vers l'adresse IP "._INSTALL_PANEL_HOST_IP,'ping');
$form->addElement('password','password1','Mot de passe :');
$form->addElement('password','password2','Confirmation :');
$form->addRule('password1', 'Vous devez saisir un mot de passe', 'required', '', 'server');
$form->addRule('password2', 'Vous devez saisir la confirmation du mot de passe', 'required', '', 'server');
$form->addRule('password1','Le mot de passe doit contenir de 5 à 10 caractères','rangelength',array(5, 10), 'server');
$form->addRule('password1', "Le mot de passe ne doit pas contenir d'espace", 'regex', '/^[\S]+$/');
$form->registerRule('compare','function','compare_field');
$form->addRule('password1','Les mots de passe ne correspondent pas','compare','password2'); 

// BOUTON DE VALIDATION DU FORMULAIRE
$form->addElement('submit', 'submit', 'Ok');

// TRAITEMENT DU FORMULAIRE
if ($form->isSubmitted() && $form->validate()) {
	
	// Connection BD
	$link = @mysql_connect(_INSTALL_PANEL_HOST_DB,_INSTALL_PANEL_USER_DB, _INSTALL_PANEL_PASS_DB);
	@mysql_select_db(_INSTALL_PANEL_NAME_DB);
	
	// Recuperation des infos du formulaire
	$firstname=$form->exportValue('firstname');
	$lastname=$form->exportValue('lastname');
	$name=ucfirst(strtolower($firstname))." ".strtoupper($lastname);
	$email=$form->exportValue('mail');
	$url=$form->exportValue('url');
	$password=$form->exportValue('password1');
	
	$login=_INSTALL_USER_LOGIN_PREFIX.prefixe_mutualisation($url);
	$code=salt();
	$directory=_INSTALL_PANEL_SITES_DIRECTORY.$url;
	
	$sql = "INSERT INTO "._INSTALL_PANEL_NAME_TABLE
			."(login,password,url,directory,prenom,nom,email,moderateur,code) VALUES("
			."'".addslashes($login)."',"
			."'".md5($password)."',"
			."'$url',"
			."'$directory',"
			."'".addslashes($firstname)."',"
			."'".addslashes($lastname)."',"
			."'".addslashes($email)."',"
			."'".$moderateur->getAuthData('uid')."',"
			."'".$code."'"
			.")";
	
	@mysql_query($sql);
	
	
	// EXEMPLE D'ENVOI AUTOMATIQUE DU MAIL D'INVITATION
	$cr="\n";
	$msg="Bonjour ".$name.$cr.$cr;
	$msg.=$moderateur->getAuthData('prenom').' '.$moderateur->getAuthData('nom')." vous invite a disposer d'un site Web fonctionnant avec le systeme de gestion de contenu SPIP (http://www.spip.net)".$cr.$cr;
	$msg.="Votre espace est accessible a partir de l'URL http://".$url.$cr.$cr;
	
	$msg.="Activation de votre site :".$cr.$cr;
	$msg.="Pour activer votre espace et configurer spip, vous devez vous rendre sur http://".$url;
	$msg.=" et utiliser le code d'activation suivant : ".$code.$cr.$cr;
	
	$msg.="Parametres techniques :".$cr.$cr;
	$msg.="- Serveur FTP : $url / Identifiant : ".$login." / Mot de passe : ".$password.$cr;
	$msg.="- Serveur Mysql : localhost / Identifiant : ".$login." / Mot de passe : ".$password.$cr;
	$msg.="- phpMyAdmin : https://sql.mondomain.tld".$cr.$cr;
	$msg.="Regles de bonne conduite :".$cr.$cr;
	$msg.="- Vous devez respecter la charte d'hebergement http://mondomain.tld/charte.html".$cr.$cr;
	
	$msg.="En vous souhaitant bonne publication !".$cr;
	
	
	// Envoi du mail
	$headers['From'] = 'toto@mondomain.tld';
	$recipients= $email;
	$headers['To'] = $email;
	$headers['Subject'] = "Invitation / ouverture du site spip http://".$url;
	$headers['Content-Type'] = 'text/plain; charset=ISO-8859-1';
	
	$mail_object =& Mail::factory('smtp');
	$mail_object->send($recipients, $headers, $msg);
	
	// On confirme que le courrier a bien ete envoye
	echo "<p>Un courrier précisant le code d'activation du site, les identifiants FTP et MySQL a été envoyé à $email</p>";	
	echo '<p><a href="index.php">Inviter une nouvelle personne</a></p>';
	echo '<p>Copie du courrier :</p><p style="font-size:10px">'.str_replace($cr,"<br />",$msg).'</p>';
	

}
else {
	// Affichage du formulaire
	$form->accept($renderer);
	echo $renderer->toHtml();
}



// Inclusion pied de la page HTML
include 'include/footer.inc.php';
?>